<script setup lang="ts">
import ShortcutsModalButton from "@/components/molecules/modal/ShortcutsModalButton.vue";
import {FwbToggle} from "flowbite-vue";
import {computed, ComputedRef, onMounted, onUnmounted} from "vue";
import ModalTitle from "@/components/atoms/modal/ModalTitle.vue";
import ShortcutsSection from "@/components/organisms/section/Shortcut/ShortcutsSection.vue";
import {useShortcutsModalStore} from "@/stores/Shortcuts/ShortcutsModalStore";
import {useShortcutsStore} from "@/stores/Shortcuts/ShortcutsStore";
import {useShortcutsListenerStore} from "@/stores/Shortcuts/ShortcutsListenerStore";
import {findShortcutWithShortcutEnum, SHORTCUTS, SHORTCUTS_PER_SECTION} from "@/constants/SHORTCUTS_PER_SECTION";
import type Shortcut from "@/entities/Shortcut/Shortcut";
import Dialog from "primevue/dialog";

const showShortcutsModal = useShortcutsModalStore();
const showShortcuts = useShortcutsStore();
const shortcutsListener = useShortcutsListenerStore();

const showModalShortcutsShortcut: ComputedRef<Shortcut | null> = computed(() => findShortcutWithShortcutEnum(SHORTCUTS.SHOW_SHORTCUTS_MODAL))
const hideShortcutsShortcut: ComputedRef<Shortcut | null> = computed(() => findShortcutWithShortcutEnum(SHORTCUTS.HIDE_SHORTCUTS))

function shortcutHandler(event: KeyboardEvent) {
  if (showModalShortcutsShortcut.value?.isValidEvent(event)) {
    showShortcutsModal.toggle();
  } else if (hideShortcutsShortcut.value?.isValidEvent(event)) {
    showShortcuts.toggle();
  }
}

onMounted(() => {
  shortcutsListener.addListener(shortcutHandler);
})

onUnmounted(() => {
  shortcutsListener.removeListener(shortcutHandler);
})
</script>

<template>
  <div>
    <ShortcutsModalButton/>
    <Dialog v-model:visible="showShortcutsModal.visible" closeOnEscape modal :style="{ maxWidth: '50rem' }">
      <template #header>
        <ModalTitle>Liste des raccourcis</ModalTitle>
      </template>
      <template #default>
        <ShortcutsSection
            :section="section"
            :class="(sectionIndex < SHORTCUTS_PER_SECTION?.length - 1) ? 'mb-10' : ''"
            v-for="(section, sectionIndex) in SHORTCUTS_PER_SECTION"
            :key="'shortcut_' + sectionIndex"
        />
      </template>
      <template #footer>
        <FwbToggle v-model="showShortcuts.visible" label="Afficher les raccourcis"/>
      </template>
    </Dialog>
  </div>
</template>
